import modules.*;
import terminalui.TerminalUI;
import auxiliary.*;

public class Main {
	public static void main(String[] args) throws Exception {
 
			Runtime.getRuntime().addShutdownHook(new FinalizingThread());
		
			//100 ty commit (Petrz)
            CommandLineReader clr = new CommandLineReader();
            if (!clr.readCommandLine(args)) {
                    CommandLineReader.printUsage();
                    return;
            }
            
 
            DataStorage.setPort(clr.port());
            DataStorage data = DataStorage.getInstance();
            
            //!TODO -- test implementation
            data.SharedFiles().init();
            data.DownloadedFiles().init();
            
            Thread network = new Thread(data.getCommunicationInstance());
            Thread peerMgmt = new Thread(data.getPeerManagementInstance());
            Thread searchModul = new Thread(data.getSearchInstance());
            Thread searchAnswer = new Thread(data.getSearchAnswerInstance());
            Thread downloadModul = new Thread(data.getDownloadInstance());
            Thread uploadModul = new Thread(data.getUploadInstance());
            
            network.start();
            peerMgmt.start();
            searchModul.start();
            searchAnswer.start();
            downloadModul.start();
            uploadModul.start();
            
            if (!clr.gui()) {
                    Thread tuiThread = new Thread(new TerminalUI());
                    tuiThread.start();
                    tuiThread.join();
            } else {
                    Thread guiThread = new Thread(new GUIModule());
                    guiThread.start();
                    guiThread.join();
            }
            
            System.exit(0);

	}
}
