package gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashMap;

//Singleton
public class ActionDatabase {

	protected HashMap<String, ActionListener> data;
	
	protected ActionDatabase(){
		this.data = new HashMap<String, ActionListener>();		
	}
	
	//!TODO -- getting action before it is created
	public ActionListener getAction(String name){
		//Creates an empty action, which is referenced
		if(!this.data.containsKey(name)){
			this.data.put(name, new ActionListener(){
				@Override
				public void actionPerformed(ActionEvent arg0) {
				}
			});
		}
		
		return this.data.get(name);
	}
	
	//!TODO 
	public void addAction(String name, ActionListener action){
		data.put(name, action);
	}
	
	//Singleton functionality
	public static ActionDatabase getInstance(){
		if(_instance == null){
			_instance = new ActionDatabase();
		}
		return _instance;
	}
	
	private static ActionDatabase _instance = null; 
}
