package gui;

import java.awt.event.ActionListener;

import javax.swing.JMenuItem;
import javax.swing.KeyStroke;

public class MenuItemDescriptor {
	
	//Default constructor
	public MenuItemDescriptor(){
		
	}
	
	//Copy constructor
	public MenuItemDescriptor(MenuItemDescriptor d) {
		this.id = d.id;
		
		this.parent = d.parent;
		
		if(d.name_to_show != null) this.name_to_show = new String(d.name_to_show);
		if(d.tooltip != null) this.tooltip = new String(d.tooltip);
		if(d.icon_name != null) this.icon_name = new String(d.icon_name);
		
		this.hotkey = d.hotkey;
		this.shortcut = d.shortcut;
		
		this.action = d.action;
		
		this.component = d.component;
		
		this.separator_before_me = d.separator_before_me;
		this.is_checkbox = d.is_checkbox;
	}
	//if something is null, then it will be not set
	
	public int id = -1;
	
	//Is set by MenuManager.add(MenuItemDescriptor, parent_id)
	//assert(parent_id < this.is)
	public MenuItemDescriptor parent = null;
	
	public String name_to_show = "NOT SET";
	public String tooltip = null;  		
	public String icon_name = null;
	
	//KeyEvent.VK_
	public int hotkey = -1;
	public KeyStroke shortcut = null;
	
	public ActionListener action = null; 
	
	//This will be set at runtime in MenuManager
	public JMenuItem component = null; 
	
	//Line separator (for example between logically related groups of items)
	public boolean separator_before_me = false;
	
	//If show also a checkbox before MenuItem.name (implemented via JCheckBoxMenuItem)
	public boolean is_checkbox = false;
}
