package modules;

import java.util.ArrayList;

public class DebugCollector {
	public interface DebugCollectorObserver {
		void messageThrown(String description);
	}
	
	private ArrayList<DebugCollectorObserver> observers = new ArrayList<DebugCollectorObserver>();
	
	public void throwMessage(String description) {
		for (DebugCollectorObserver o: observers)
			o.messageThrown(description);
	}
	
	public void addObserver(DebugCollectorObserver observer) {
		observers.add(observer);
	}
}
