package modules;

import java.util.ArrayList;

public class ErrorCollector {
	
	public interface ErrorCollectorObserver {
		void errorRaised(String description);
	}
	
	private ArrayList<ErrorCollectorObserver> observers = new ArrayList<ErrorCollectorObserver>();
	
	public void raiseError(String description) {
		for (ErrorCollectorObserver o: observers)
			o.errorRaised(description);
	}
	
	public void addObserver(ErrorCollectorObserver observer) {
		observers.add(observer);
	}
}
