package modules;

import types.*;

import java.util.Collections;
import java.util.TreeSet;
import java.util.Set;

public class RecentlyDeletedList {
        private Set<PeerList.IPAddress> list;
    
        RecentlyDeletedList() {
                list = Collections.synchronizedSet(new TreeSet<PeerList.IPAddress>());
        }
        
        public synchronized void addToList(PeerList.IPAddress addr) {
                list.add(addr);
        }
        
        public synchronized void clearList() {
                list.clear();
        }
        
        public synchronized boolean isInList(PeerList.IPAddress addr) {
                return list.contains(addr);
        }
}
