package terminalui;

public class HelpCommand extends Command {

	@Override
	public CmdReturn execute(String[] args) {
		String[] supportedFlags = {};
		if (!parseArgs(args, supportedFlags)) return CmdReturn.INVALID_SYNTAX;
		
		if (this.args.length >= 1) return helpForCommand(this.args[0]);
		
		return commandList();
	}
	
	private CmdReturn helpForCommand(String command) {
		Command cmd = Command.commandFromString(command);
		cmd.help();
		return CmdReturn.SUCCESS;
	}
	
	private CmdReturn commandList() {
		SYSTEM.outln("TazUP command list");
		String[] cmd = Command.commandsToStringArray();
		for (String c: cmd)
			TEXT.outln(c);
		
		return CmdReturn.SUCCESS;
	}

	@Override
	public void help() {
		TEXT.out("You are helpless case. Helpless case. Helpless...\n");
	}

}
