package types;

import auxiliary.Convert;

public class SearchID extends ID {
	
	public SearchID(int value){
		this.value = value;
	}
	
	@Override
	public boolean equals(Object obj) {
		if (! (obj instanceof SearchID)) return false;
		SearchID sid = (SearchID) obj;
		return (value == sid.value());
	}
	
	@Override
	public int hashCode() {
		return value;
	}
	
	public static SearchID searchIDfromBytes(byte[] bytes, int offset) {
		if (bytes == null) return null;
		if (bytes.length < 4+offset) return null;
		
        return new SearchID(Convert.bytesToInt(bytes, offset));
	}
}
