package types;

import auxiliary.Convert;

public class SequenceID extends ID{
	
	public SequenceID(int value) {
		this.value = value;
	}
	
	@Override
	public boolean equals(Object obj) {
		if (! (obj instanceof SequenceID)) return false;
		SequenceID sid = (SequenceID) obj;
		return (value == sid.value());
	}
	
	public static SequenceID sequenceIDfromBytes(byte[] bytes, int offset) {
		if (bytes == null) return null;
		if (bytes.length < 4+offset) return null;
		
        return new SequenceID(Convert.bytesToInt(bytes, offset));
	}
}
