#!/bin/bash
#
# tazup32.sh
# used to run java app
#
# what it does:
#		1. compiles *.java files in src/ directory (and subdirs), includes
#			*.jar files in lib/ directory
#		2. runs Main.class with arguments added to script

if [ ! -d bin ] 
then 
	mkdir bin
fi

echo "tazup.sh: looking for changed files..."

for file in `find src -name *.java`
do
	class=`echo $file | sed 's/^src/bin/' | sed 's/java$/class/'` 
	
	if [ ! -f $class ] || [ $class -ot $file ]
	then
		echo "tazup.sh: compiling $file"
		javac -proc:none -cp lib/x32/*:src/ -d bin $file
	fi
done

echo "tazup.sh: starting..."
java -cp lib/x32/*:bin/ Main $*
