package testmodules;

import java.net.InetAddress;
import java.net.UnknownHostException;

import types.PeerID;
import types.PeerInfo;
import modules.Communication;
import modules.DataStorage;

public class DataStorageTestingSubclass extends DataStorage {

	@Override
	public Communication getCommunicationInstance() {
		if (communication == null)
			communication = new MirrorCommunication();
		return communication;
	}
	
	@Override
	public PeerInfo[] getActivePeers() {	
		PeerInfo[] r = super.getActivePeers();
		if (r.length > 0) return r;
		
		r = new PeerInfo[1];
		try {
			r[0] = new PeerInfo(myPeerID(), InetAddress.getLocalHost(), myPort());
		} catch (UnknownHostException e) {
			throw new RuntimeException("wtf");
		}
		return r;
	}
	
	public static DataStorage getInstance() {
		if (_instance == null)
			_instance = new DataStorageTestingSubclass();
		return _instance;
	}
}
