package testmodules;

import java.io.IOException;
import java.util.HashMap;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.TimeUnit;

import modules.Communication;

import types.Message;
import types.ModulType;

public class MirrorCommunication implements Communication {

	private boolean exit = false;
	private int MESSAGE_BUFFER_SIZE = 100;	
	HashMap<ModulType, ArrayBlockingQueue<Message> > storage;
	
	private Thread thread;
	
	public MirrorCommunication() {
		storage = new HashMap<ModulType, ArrayBlockingQueue<Message>>();
		for (ModulType t: ModulType.values())
			storage.put(t, new ArrayBlockingQueue<Message>(MESSAGE_BUFFER_SIZE));
	}
	
	@Override
	public Message receiveMessage(ModulType modul) throws InterruptedException {
		Message msg = storage.get(modul).take();
		//System.out.println("" + modul + " received message:\n" + msg.toString());
		return msg;
	}
	
	@Override
	public Message receiveMessage(ModulType modul, long timeout, TimeUnit unit) throws InterruptedException {
		return storage.get(modul).poll(timeout, unit);
	}

	@Override
	public void sendMessage(Message msg) throws IOException {
		boolean put = false;
		while (!put) {
			try {
				storage.get(msg.targetModule()).put(msg);
				put = true;
				//System.out.println("Sent message for " + msg.targetModule() + "\n" + msg.toString());
			} catch (InterruptedException e) {}
		}
	}

	@Override
	public void exit() {
		exit = true;
		thread.interrupt();
	}

	@Override
	public void run() {
		thread = Thread.currentThread();
		while (!exit) {
			try {
				Thread.sleep(60000);
			} catch (InterruptedException e) {
				continue;
			}
		}
	}

}
