package tests;


import auxiliary.Convert;
import junit.framework.TestCase;

public class ConvertTest extends TestCase {

	// int conversion
	public void testBytesToInt_zero() {
		int x = 0;
		if (x != Convert.bytesToInt(Convert.intToBytes(x), 0)) fail();
	}
	
	public void testBytesToInt_positive() {
		int x = 678;
		if (x != Convert.bytesToInt(Convert.intToBytes(x), 0)) fail();
	}
	
	public void testBytesToInt_random() {
		int x = 65540;
		if (x != Convert.bytesToInt(Convert.intToBytes(x), 0)) fail();
	}
	
	public void testBytesToInt_negative() {
		int x = -324;
		if (x != Convert.bytesToInt(Convert.intToBytes(x), 0)) fail();
	}
	
	public void testBytesToInt_minValue() {
		int x = Integer.MIN_VALUE;
		if (x != Convert.bytesToInt(Convert.intToBytes(x), 0)) fail();
	}
	
	public void testBytesToInt_maxValue() {
		int x = Integer.MAX_VALUE;
		if (x != Convert.bytesToInt(Convert.intToBytes(x), 0)) fail();
	}
	// short  conversion
	public void testBytesToShort_zero() {
		short x = 0;
		if (x != Convert.bytesToShort(Convert.shortToBytes(x), 0)) fail();
	}
	
	public void testBytesToShort_positive() {
		short x = 678;
		if (x != Convert.bytesToShort(Convert.shortToBytes(x), 0)) fail();
	}
	
	public void testBytesShort_negative() {
		short x = -324;
		if (x != Convert.bytesToShort(Convert.shortToBytes(x), 0)) fail();
	}
	
	public void testBytesToShort_minValue() {
		short x = Short.MIN_VALUE;
		if (x != Convert.bytesToShort(Convert.shortToBytes(x), 0)) fail();
	}
	
	public void testBytesToShort_maxValue() {
		short x = Short.MAX_VALUE;
		if (x != Convert.bytesToShort(Convert.shortToBytes(x), 0)) fail();
	}
	// long conversion
	public void testBytesToLong_zero() {
		long x = 0;
		if (x != Convert.bytesToLong(Convert.longToBytes(x), 0)) fail();
	}
	
	public void testBytesToLong_positive() {
		long x = 678;
		if (x != Convert.bytesToLong(Convert.longToBytes(x), 0)) fail();;
	}
	
	public void testBytesToLong_negative() {
		long x = -324;
		if (x != Convert.bytesToLong(Convert.longToBytes(x), 0)) fail();
	}
	
	public void testBytesToLong_minValue() {
		long x = Long.MIN_VALUE;
		if (x != Convert.bytesToLong(Convert.longToBytes(x), 0)) fail();
	}
	
	public void testBytesToLong_maxValue() {
		long x = Long.MAX_VALUE;
		if (x != Convert.bytesToLong(Convert.longToBytes(x), 0)) fail();
	}
	/*
	public static byte alphaHexToByte(char c1)
	public static byte alphaHexToByte(char c1, char c2)
	public static String byteToAlphaHex(byte b)
	public static byte[] alphaHexStringToBytes(String s)
	public static byte[] alphaHexStringToBytes(String s, int length)
	public static String bytesToAlphaHexString(byte[] data)*/
	public void testAlphaHexToByte_maxValue(){
		byte b=Byte.MAX_VALUE;
		
		for(b = Byte.MIN_VALUE; b < Byte.MAX_VALUE ; b++){
		  System.out.println(b + " " + Convert.byteToAlphaHex(b) + " " + Convert.alphaHexToByte(Convert.byteToAlphaHex(b)));
		}
		if(b != Convert.alphaHexToByte(Convert.byteToAlphaHex(b))) fail();
	}
	public void testAlphaHexToByte_minValue(){
		byte b=Byte.MIN_VALUE;
		System.out.print(b);
		System.out.println(" " + Convert.byteToAlphaHex(b));
		if(b != Convert.alphaHexToByte(Convert.byteToAlphaHex(b))) fail();
	}
	public void testAlphaHexToByte_1(){
		String s = "abbcc1d1fe516cfd156318";
		//System.out.println("'" + s + "' " + Convert.alphaHexStringToBytes(s).toString() + " " + "\n'" + Convert.bytesToAlphaHexString(Convert.alphaHexStringToBytes(s)) + "'");
		//byte[] con = Convert.alphaHexStringToBytes(s);
		//for(int i=0; i<con.length ; i++) {System.out.print(con[i]); System.out.print(" ");}
		//System.out.println();
		//Remarkable error: Why --if(a.equals(b)) fail();-- fails if in the log a is the same as b? 
		if(!s.equals(Convert.bytesToAlphaHexString(Convert.alphaHexStringToBytes(s)))) fail();
	}
	public void testAlphaHexToByte_2(){
		String s = "";
		if(!s.equals(Convert.bytesToAlphaHexString(Convert.alphaHexStringToBytes(s)))) fail();
	}
	public void testAlphaHexToByte_3(){
		String s = "0000000000000000000000";
		if(!s.equals(Convert.bytesToAlphaHexString(Convert.alphaHexStringToBytes(s)))) fail();
	}
	public void testAlphaHexToByte_4(){
		String s = "a0bf1238ec849e49bc31ef8a9b13ce89b46f463d1bc0";
		if(!s.equals(Convert.bytesToAlphaHexString(Convert.alphaHexStringToBytes(s)))) fail();
	}
	public void testAlphaHexToByte_5(){
		//Generating longer bytes than input stream
		System.out.println(Convert.bytesToAlphaHexString(Convert.alphaHexStringToBytes("",10)));
		if(!"00000000000000000000".equals(Convert.bytesToAlphaHexString(Convert.alphaHexStringToBytes("",10)))) fail();
	}
	public void testAlphaHexToByte_6(){
		//Generating shorter bytes than input stream
		if(!"0000".equals(Convert.bytesToAlphaHexString(Convert.alphaHexStringToBytes("0000abcefbc124f8",2)))) fail();
	}
}
