package tests;

import java.io.File;

import modules.*;
import types.*;
import testmodules.DataStorageTestingSubclass;
import junit.framework.TestCase;

public class DownloadTest extends TestCase {
	DataStorage ds;
	Communication comm;
	DownloadModul dm;
	UploadModul um;
	SharedFilesDatabase sfd;
	DownloadedFilesDatabase dfd;
	SharedFileDescriptor shared_file;
	
	public DownloadTest() {
		System.out.println("Construct");
		ds = DataStorageTestingSubclass.getInstance();
		comm =  ds.getCommunicationInstance();
		dm = ds.getDownloadInstance();
		um = ds.getUploadInstance();
		sfd = ds.SharedFiles();
		dfd = ds.DownloadedFiles();
		
		shared_file = new SharedFileDescriptor("share/file1.txt");
		sfd.add(shared_file);
		System.out.println("File shared: " + shared_file.getTargetChecksum());
		
		(new Thread(dm)).start();
		(new Thread(um)).start();
	}
	
	public void testInit(){
		String filenameToSave = "file1down.txt";
		
		SearchResult sr = new SearchResult(
				ds.myPeerID(),
				filenameToSave, 
				0, 
				shared_file.getTargetChecksum());
		
		dm.startDownloadFile(sr);
		
		try {
			Thread.sleep(1000);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		dm.exit();
		um.exit();
		System.out.println("Finalize");
		
		//(new File("share/" + filenameToSave)).delete();
	}
	
	protected void finalize(){
	}
	
	
}
