package tests;

import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.TreeSet;

import junit.framework.TestCase;
import types.*;

public class SearchQueryTest extends TestCase {
	
	public void testConversion() {
		SearchQuery sq = new SearchQuery();
		sq.ttl = 10;
		try {
			sq.initiator = new PeerInfo(new PeerID(0), InetAddress.getLocalHost(), 4747);
		} catch (UnknownHostException e) {
			fail();
		}
		sq.keywords = new TreeSet<String>();
		sq.keywords.add("string");
		sq.keywords.add("strang");
		sq.keywords.add("strung");
		
		byte[] bytes = sq.getBytes();
		
		SearchQuery nsq = SearchQuery.querryWithBytes(bytes);
		
		if (nsq == null) fail();
		
		if (sq.ttl != nsq.ttl) fail();
		
		if (nsq.keywords == null) fail();
		if (nsq.keywords.size() != sq.keywords.size()) fail();
		for (String s: nsq.keywords)
			if (!sq.keywords.contains(s)) fail();
	}
	
}
